#include <iostream>
#include <vector>
#include <queue>


using namespace std;

int niz[500000];

int main()
{
    int i, n, k, star, gotovo = 0;
    cin >> n >> k;
    vector<int> ignorindeks;
    for (i = 0; i < n; i++)
    {
        cin >> niz[i];

        if (i != 0)
        {
            if ((!gotovo) && (star > niz[i]))
            {
                ignorindeks.push_back(i-1);
                if (ignorindeks.size() == k)
                {
                    gotovo = 1;
                }
            }
        }

        star = niz[i];
    }

    for (i = 0; i < n; i++)
    {
        if (!ignorindeks.empty())
        {
            if (i == ignorindeks.at(0))
            {
                ignorindeks.erase(ignorindeks.begin()+0);
                continue;
            }
        }
        cout << niz[i] << ' ';
    }

    return 0;
}